SystemOrganization addCategory: #'Orange-Xtreams'!

TestCase subclass: #PEGNonTerminalsTest
	instanceVariableNames: 'flow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Xtreams'!

!PEGNonTerminalsTest commentStamp: 'chc 7/22/2015 15:09' prior: 0!
An NonTerminal is an OrderedCollection that contains other OrderedCollections. In the #grammarWiki that could be:

Paragraph <- Line

Line could contain several OrderedCollections of different chars and strings. !

!PEGNonTerminalsTest methodsFor: 'as yet unclassified' stamp: 'chc 7/22/2015 14:50'!
doGenerate: flow
	| alltogether |
	alltogether := String new writing.
	flow do: [:ea| alltogether write: ea].
	^alltogether conclusion! !

!PEGNonTerminalsTest methodsFor: 'as yet unclassified' stamp: 'chc 7/22/2015 14:50'!
setUp
	| flowoc |
	flowoc := OrderedCollection new. 
	flowoc add: $a; add: $b; add: $c. 
	flow := flowoc! !

!PEGNonTerminalsTest methodsFor: 'as yet unclassified' stamp: 'chc 7/22/2015 14:50'!
testBold
	| result |
	result := self doGenerate: flow.
	result := '<bold>' , result , '</bold>'.
	self assert: ( '<bold>abc</bold>' = result )! !

TestCase subclass: #PEGTerminalsTest
	instanceVariableNames: 'flow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Xtreams'!

!PEGTerminalsTest commentStamp: 'chc 7/22/2015 15:10' prior: 0!
A terminal here is an OrderedCollection that does not contain another OrderedCollection. A terminal's contents is chars or strings. In the #grammarWiki that could be: 

Bold <- "*" Flow{"*"}

Angle brackets (i.e. {}) show that something is optional. To create a bold word you need an asterisk befor a or line. It will not contain any further OrderedCollections.  !

!PEGTerminalsTest methodsFor: 'as yet unclassified' stamp: 'chc 7/22/2015 14:40'!
doGenerate: flow
	| alltogether |
	alltogether := String new writing.
	flow do: [:ea| alltogether write: ea].
	^alltogether conclusion! !

!PEGTerminalsTest methodsFor: 'as yet unclassified' stamp: 'chc 7/22/2015 14:43'!
setUp
	| flowoc |
	flowoc := OrderedCollection new. 
	flowoc add: $a; add: $b; add: $c. 
	flow := flowoc! !

!PEGTerminalsTest methodsFor: 'as yet unclassified' stamp: 'chc 7/22/2015 14:48'!
testBold
	| result |
	result := self doGenerate: flow.
	result := '<bold>' , result , '</bold>'.
	self assert: ( '<bold>abc</bold>' = result )! !

!PEGTerminalsTest methodsFor: 'as yet unclassified' stamp: 'chc 7/22/2015 14:50'!
testItalic
	| result |
	result := self doGenerate: flow.
	result := '<italic>' , result , '</italic>'.
	self assert: ( '<italic>abc</italic>' = result )! !

!PEGTerminalsTest methodsFor: 'as yet unclassified' stamp: 'chc 7/22/2015 14:53'!
testOrderedList
	| result |
	result := self doGenerate: flow.
	result := '<ul><li>' , result , '</li></ul>'.
	self assert: ( '<ul><li>abc</li></ul>' = result )! !

!PEGTerminalsTest methodsFor: 'as yet unclassified' stamp: 'chc 7/22/2015 14:54'!
testUnorderedList
	| result |
	result := self doGenerate: flow.
	result := '<ol><li>' , result , '</li></ol>'.
	self assert: ( '<ol><li>abc</li></ol>' = result )! !

PEGActor subclass: #PEGWikiGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Xtreams'!

!PEGWikiGenerator methodsFor: 'lexical' stamp: 'chc 7/22/2015 14:42'!
Bold: flow
	<action: 'Bold' arguments: #( 2 )>
	^'<bold>' , (self doGenerate: flow) , '</bold>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/15/2015 22:29'!
Heading1: flow
	<action: 'Heading1' arguments: #(3) >
	^'<h1>' , (self doGenerate: flow) , '</h1>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/15/2015 13:59'!
Heading2: flow
	<action: 'Heading2' arguments: #(3) >
	^'<h2>' , (self doGenerate: flow) , '</h2>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/15/2015 14:00'!
Heading3: flow
	<action: 'Heading3' arguments: #(3) >
	^'<h3>' , (self doGenerate: flow) , '</h3>'! !

!PEGWikiGenerator methodsFor: 'lexical' stamp: 'chc 7/14/2015 14:27'!
Italic: flow
	<action: 'Italic' arguments: #( 2 )>
	^'<italic>' , (self doGenerate: flow)  ,  '</italic>'! !

!PEGWikiGenerator methodsFor: 'lexical' stamp: 'chc 7/15/2015 22:31'!
Link: flow
	<action: 'LinkShort' arguments: #( 2 )>
	| linkContent |
	linkContent := self doGenerate: flow.
	^'<a href="http://www.' , linkContent , '.com">' , linkContent , '</a>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/22/2015 15:13'!
ListItem: bullets flow: flow
	<action: 'Bullet1' arguments: #(2 3)>
	^'<li>' , (self doGenerate: flow) , '</li>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/14/2015 14:29'!
Page: lines
	<action: 'Page'>
	^'<div>' , (self doGenerate: lines) , '</div>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/14/2015 14:29'!
Paragraph: flow
	<action: 'Paragraph'>
	^'<p>' , (self doGenerate: flow) , '</p>'! !

!PEGWikiGenerator methodsFor: 'private' stamp: 'chc 7/14/2015 14:35'!
doGenerate: flow
	| alltogether |
	alltogether := String new writing.
	flow do: [:ea| alltogether write: ea].
	^alltogether conclusion! !
